/***************************************************
*  C source with CCS
*  File Name: 20170505_K485B_MK623_1933.c
 * rev 1.0 
 * rev 2.0 with 1933
*  Description: 
*  2017 MYCOMKITS.COM, owned by CNET LIMITED
***************************************************/
// include header file
#define RAND_MAX 100 // generate random number 0 to 100
#include <16f1933.h>
#DEVICE ADC=8
#fuses	INTRC_IO, NOWDT, NOMCLR, NOBROWNOUT, PUT, NOLVP, NOPROTECT, NODEBUG
#fuses	NOCPD, NOCLKOUT, NOWRT, NOIESO, NOFCMEN, PLL_SW, NOSTVREN
#use	delay(CLOCK = 32000000)
#include <stdlib.h>
//#USE PWM(options)
//
#use	fast_io(a)
#use	fast_io(b)
#use	fast_io(c)
#use	fast_io(e)
//
#byte OSCCON = 0x099
#byte APFCON0 = 0x11D
#byte CCPTMRS = 0x29E
#byte WPUB = 0x20D
#byte WPUE = 0x210
#byte OPTION_REG = 0x95
//
#ROM 0x1f00 = {0x01, 0x01}
//
#define saved_address 0
#define	Amode 0x07      //port A all output, except A0,1,2
#define	Bmode 0x00      //port B all output
#define	Cmode 0x00      //port C all output
#define	Emode 0xFF      //port E all input
// port define for output and function
#define disp2_cp PIN_A3      //
#define disp2_ds PIN_A7      //
#define disp1_cp PIN_A5      //
#define disp1_ds PIN_A6      //
//#define red5mm_led1 PIN_A7      //
//#define red5mm_led2 PIN_A6      //
//#define red_relay PIN_A5      //
#define buzzer PIN_A4      //
#define mode_sw PIN_E3      //

//long int n;
// pattern
int const roc[8] = {0x00, 0x18, 0x3c, 0x7e, 0x7e, 0x3c, 0x18, 0x00};
int const sci1[8] = {0xf0, 0x3c, 0x1e, 0x0f, 0x0f, 0x1e, 0x3c, 0xf0};
int const pap[8] = {0xfc, 0xfe, 0xff, 0xff, 0xff, 0xff, 0x7f, 0x3f};
int const sci2[8] = {0x0f, 0x3c, 0x78, 0xf0, 0xf0, 0x78, 0x3c, 0x0f};
int const mode1a[8] = {0x00, 0x00, 0x00, 0x88, 0x88, 0xa8, 0xd8, 0x88};
int const mode1b[8] = {0x00, 0x00, 0x00, 0x0e, 0x04, 0x04, 0x06, 0x04};
int const mode1c[8] = {0x00, 0x00, 0x00, 0x51, 0x5b, 0x55, 0x51, 0x51};
int const mode1d[8] = {0x00, 0x00, 0x00, 0x11, 0x19, 0x15, 0x13, 0x11};
int const mode2b[8] = {0x00, 0x00, 0x00, 0x0f, 0x02, 0x04, 0x09, 0x06};
int const mode2c[8] = {0x00, 0x00, 0x00, 0x6f, 0x91, 0x91, 0x91, 0x61};
int const mode2d[8] = {0x00, 0x00, 0x00, 0xe7, 0x28, 0x66, 0x21, 0xee};
int const mode3b[8] = {0x00, 0x00, 0x00, 0x06, 0x09, 0x04, 0x09, 0x06};
int const mode3c[8] = {0x00, 0x00, 0x00, 0x66, 0x91, 0x91, 0x91, 0x66};
int const mode3d[8] = {0x00, 0x00, 0x00, 0x31, 0x35, 0x75, 0xaa, 0x60};
int const start1[8] = {0x00, 0x00, 0x00, 0x20, 0x20, 0x62, 0xa1, 0x62};
int const start2[8] = {0x00, 0x00, 0x00, 0x75, 0x15, 0x73, 0x15, 0x73};
int const start3[8] = {0x00, 0x00, 0x00, 0x60, 0x80, 0x42, 0x21, 0xc2};
int const start4[8] = {0x00, 0x00, 0x00, 0x03, 0x04, 0x02, 0x01, 0x06};
int const num0[8] = {0x00, 0x00, 0x00, 0x24, 0x2a, 0x4a, 0x8a, 0x84};
int const num1[8] = {0x00, 0x00, 0x00, 0x2e, 0x24, 0x44, 0x86, 0x84};
int const num2[8] = {0x00, 0x00, 0x00, 0x2e, 0x22, 0x4e, 0x88, 0x8e};
int const num3[8] = {0x00, 0x00, 0x00, 0x2e, 0x28, 0x44, 0x88, 0x8e};
int const num4[8] = {0x00, 0x00, 0x00, 0x28, 0x28, 0x4e, 0x8a, 0x8a};
int const num5[8] = {0x00, 0x00, 0x00, 0x2e, 0x28, 0x4e, 0x82, 0x8e};
int const num6[8] = {0x00, 0x00, 0x00, 0x2e, 0x2a, 0x4e, 0x82, 0x8e};
int const num7[8] = {0x00, 0x00, 0x00, 0x24, 0x24, 0x44, 0x88, 0x8e};
int const num8[8] = {0x00, 0x00, 0x00, 0x2e, 0x2a, 0x44, 0x8a, 0x8e};
int const num9[8] = {0x00, 0x00, 0x00, 0x2e, 0x28, 0x4e, 0x8a, 0x8e};
int const num10[8] = {0x00, 0x00, 0x00, 0x29, 0x35, 0x55, 0x95, 0x89};
int const num10b[8] = {0x00, 0x00, 0x00, 0x17, 0x2a, 0x2a, 0x2b, 0x12};
int i=0;
//int j=0;
int disp=0; // show dot pattern
int keymain;
int keysub;
int mode=1; // start value
int1 papa1=0, scis1=0, rock1=0;
int1 papa2=0, scis2=0, rock2=0;
long count_disp=10000;
long disp_value=10000;
int game_count = 0;
int pre_disp;
int seed_value=50;
long game_speed=100;
int win_count=0;
int lose_count=0;
int beep_time=12;   // 30msec
// prototyping
#separate
void beep1000();
#separate
void beep300();
#separate
void beep100();
#separate
void beep30();
#separate
void initializing();
#separate
void clear_shifter();
#separate
void test();
#separate
void mode_set();
#separate
void check_sw();
#separate
void mode_display();
#separate
void mode1_action();
#separate
void mode2_action();
#separate
void mode3_action();
#separate
void common_action();
#separate
void start_display();
#separate
void mode1_display();
#separate
void check_start();
#separate
void result_display();
#separate
void get_speed();
#separate
void save_mode();
// main program
void main()
{
    initializing();
    //
    while(1)
    {   //endless loop
        mode_set(); // set mode, and display mode number
        seed_value = seed_value + 1;
        check_start();
        if((rock1 == 1) && (mode == 1)) mode1_action();
        else if((rock1 == 1) && (mode == 2)) mode2_action();
        else if((rock1 == 1) && (mode == 3)) mode3_action();
    }
}
// beep 1000 mili seconds
#separate
void beep1000()
{
    set_pwm5_duty(0x10);	// beep
    delay_ms(1000);
    set_pwm5_duty(0x00);	// beep off
}
// beep 300 mili seconds
#separate
void beep300()
{
    set_pwm5_duty(0x10);	// beep
    delay_ms(300);
    set_pwm5_duty(0x00);	// beep off
}
// beep 100 mili seconds
#separate
void beep100()
{
    set_pwm5_duty(0x10);	// beep
    delay_ms(100);
    set_pwm5_duty(0x00);	// beep off
}
// beep 30 mili seconds
#separate
void beep30()
{
    set_pwm5_duty(0x10);	// beep
    delay_ms(30);
    set_pwm5_duty(0x00);	// beep off
}
// system intializing
#separate
void initializing()
{
    set_tris_a(Amode);	//
    set_tris_b(Bmode);	//
    set_tris_c(Cmode);	//
    set_tris_e(Emode);	//
    //
    setup_dac(DAC_OFF);
    setup_adc_ports(sAN0 | sAN1 | sAN2 | VSS_VDD);	// gnd to 5.0V
    setup_adc(ADC_CLOCK_DIV_64);	// 2usec @32MHz
    //
    OPTION_REG = OPTION_REG & 0x7F;	// set 0 to WPUEN
    WPUE = 0x08;	// pull up E3
    // initialize timer 1 for counting distance
	setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);	// 1us cycle
	set_timer1(0xF63C); // 2.5msec             // 
    //	PWM control initializing with timer2
	setup_ccp5(ccp_pwm);	//port A4
	APFCON0 = 0x01;	// set RB0 as PWM out, set it after SETUP_CCP1
	setup_timer_2(T2_DIV_BY_16,0x7F,1);
	set_pwm5_duty(0x00);
    //
    output_b(0x00);	//all LED off
    output_c(0x00);	//all LED off
    //
    srand(5);	//seed for random number
    //
    mode = read_eeprom (0);
    if((mode==0) || (mode > 3)) 
    {
        mode = 1;	// G sensor mode as default
        save_mode();
    }
    if(mode==1) disp=16;
    else if(mode==2) disp=18;
    else if(mode==3) disp=20;
    //
    enable_interrupts(INT_TIMER1);   // enable timer 1
    enable_interrupts(GLOBAL);
}
// timer 1 sub function, wait time count down the timer value at every 5msec.
#int_timer1
void isr1(void)	
{
	//set_timer1(0xEC78);	// setting timer 1 almost 5msec
    set_timer1(0xF63C);	// setting timer 1 almost 2.5msec
    //
    switch(disp)
	{
        case 0:
            output_b(roc[i]);	// 
            output_c(sci2[i]);	//
            break;
        case 1:
            output_b(sci1[i]);	// 
            output_c(pap[i]);	//
            break;
        case 2:
            output_b(pap[i]);	// 
            output_c(roc[i]);	//
            break;
        case 3:
            output_b(0);	// 
            output_c(roc[i]);	//
            break;
        case 4:
            output_b(0);	// 
            output_c(sci2[i]);	//
            break;
        case 5:
            output_b(0);	// 
            output_c(pap[i]);	//
            break;
        case 6:
            output_b(roc[i]);	// 
            output_c(roc[i]);	//
            break;
        case 7:
            output_b(sci1[i]);	// 
            output_c(roc[i]);	//
            break;
        case 8:
            output_b(sci1[i]);	// 
            output_c(sci2[i]);	//
            break;
        case 9:
            output_b(pap[i]);	// 
            output_c(sci2[i]);	//
            break;
        case 10:
            output_b(roc[i]);	// 
            output_c(pap[i]);	//
            break;
        case 11:
            output_b(pap[i]);	// 
            output_c(pap[i]);	//
            break;
        case 12:
            output_b(0);	// 
            output_c(0);	//
            break;
        case 16:
            output_b(mode1a[i]);	// 
            output_c(mode1b[i]);	//
            break;
        case 17:
            output_b(mode1c[i]);	// 
            output_c(mode1d[i]);	//
            break;
        case 18:
            output_b(mode1a[i]);	// 
            output_c(mode2b[i]);	//
            break;
        case 19:
            output_b(mode2c[i]);	// 
            output_c(mode2d[i]);	//
            break;
        case 20:
            output_b(mode1a[i]);	// 
            output_c(mode3b[i]);	//
            break;
        case 21:
            output_b(mode3c[i]);	// 
            output_c(mode3d[i]);	//
            break;
        case 22:
            output_b(start1[i]);	// 
            output_c(start2[i]);	//
            break;
        case 23:
            output_b(start3[i]);	// 
            output_c(start4[i]);	//
            break;
        case 24:
            output_b(num0[i]);	// 0/
            output_c(num10b[i]);	// 10
            break;
        case 25:
            output_b(num1[i]);	// 1/
            output_c(num10b[i]);	//
            break;
        case 26:
            output_b(num2[i]);	// 2/
            output_c(num10b[i]);	//
            break;
        case 27:
            output_b(num3[i]);	// 3/
            output_c(num10b[i]);	//
            break;
        case 28:
            output_b(num4[i]);	// 4/
            output_c(num10b[i]);	//
            break;
        case 29:
            output_b(num5[i]);	// 5/
            output_c(num10b[i]);	//
            break;
        case 30:
            output_b(num6[i]);	// 6/
            output_c(num10b[i]);	//
            break;
        case 31:
            output_b(num7[i]);	// 7/
            output_c(num10b[i]);	//
            break;
        case 32:
            output_b(num8[i]);	// 8/
            output_c(num10b[i]);	//
            break;
        case 33:
            output_b(num9[i]);	// 9/
            output_c(num10b[i]);	//
            break;
        case 34:
            output_b(num10[i]);	// 10/
            output_c(num10b[i]);	//
            break;
        case 35:
            output_b(roc[i]);	//
            output_c(0);	//
            break;
        case 36:
            output_b(sci1[i]);	// 
            output_c(0);	//
            break;
        case 37:
            output_b(pap[i]);	//
            output_c(0);	//
            break;
        case 38:
            output_b(0);	//
            output_c(0);	//
            break;
        default:
            break;
    }
    //
    if(i==0) 
    {
        output_high(disp1_ds);
        output_high(disp2_ds);
        output_high(disp1_cp);
        output_high(disp2_cp);
        output_low(disp1_cp);
        output_low(disp2_cp);
        output_low(disp1_ds);
        output_low(disp2_ds);
    }
    else
    {
        output_high(disp1_cp);
        output_high(disp2_cp);
        output_low(disp1_cp);
        output_low(disp2_cp);
    }
    i= i+1;
    if(i==8) i=0;
    if(game_speed > 0) game_speed = game_speed - 1;
    if(beep_time > 0) beep_time = beep_time - 1;
}	
//
#separate
void test()
{
    clear_shifter();
    //
    //disp=23;
    disable_interrupts(INT_TIMER1);
    output_high(disp1_ds);
        output_high(disp2_ds);
        output_high(disp1_cp);
        output_high(disp2_cp);
        output_low(disp1_cp);
        output_low(disp2_cp);
        output_low(disp1_ds);
        output_low(disp2_ds);
    while(1)
    {
        output_c(0xff);	//
        
    }
}
//
#separate
void clear_shifter()
{
    output_low(disp1_ds);
    output_low(disp2_ds);
    int k;
    for(k=0; k<8; k++)
    {
        output_high(disp1_cp);
        output_high(disp2_cp);
        output_low(disp1_cp);
        output_low(disp2_cp);
    }
}
//
#separate
void check_sw()
{
    disable_interrupts(INT_TIMER1);
    if(papa1+scis1+papa1==0)
    {
        set_adc_channel(1);	//must wait 65u
        delay_us(65);
        keymain = read_adc();
    }
    if(papa2+scis2+papa2==0)
    {
        set_adc_channel(2);	//must wait 65u
        delay_us(65);
        keysub = read_adc();
    }
    enable_interrupts(INT_TIMER1);
    if(keymain < 38) 
    {
        papa1 = 1;
        scis1 = 0;
        rock1 = 0;
    }
    else if(keymain < 102)
    {
        papa1 = 0;
        scis1 = 1;
        rock1 = 0;
    }
    else if(keymain < 191)
    {
        papa1 = 0;
        scis1 = 0;
        rock1 = 1;
    }
    else
    {
        papa1 = 0;
        scis1 = 0;
        rock1 = 0;
    }
    //
    if(keysub < 38) 
    {
        papa2 = 1;
        scis2 = 0;
        rock2 = 0;
    }
    else if(keysub < 102)
    {
        papa2 = 0;
        scis2 = 1;
        rock2 = 0;
    }
    else if(keysub < 191)
    {
        papa2 = 0;
        scis2 = 0;
        rock2 = 1;
    }
    else
    {
        papa2 = 0;
        scis2 = 0;
        rock2 = 0;
    }
    /*
    while((keymain < 191) || (keysub < 191)) 
    {
        disable_interrupts(INT_TIMER1);
        set_adc_channel(1);	//must wait 65u
        delay_us(65);
        keymain = read_adc();
        set_adc_channel(2);	//must wait 65u
        delay_us(65);
        keysub = read_adc();
        enable_interrupts(INT_TIMER1);
    }
    */
}
//
#separate
void check_start()
{
    disable_interrupts(INT_TIMER1);
    set_adc_channel(1);	//must wait 65u
	delay_us(65);
	keymain = read_adc();
    //set_adc_channel(2);	//must wait 65u
	//delay_us(65);
	//keysub = read_adc();
    enable_interrupts(INT_TIMER1);
    if(keymain < 38) 
    {
        papa1 = 1;
        scis1 = 0;
        rock1 = 0;
    }
    else if(keymain < 102)
    {
        papa1 = 0;
        scis1 = 1;
        rock1 = 0;
    }
    else if(keymain < 191)
    {
        papa1 = 0;
        scis1 = 0;
        rock1 = 1;  // start
        srand(seed_value);	//seed for random number;
        //clear_shifter();
        disp=12;
    }
    else
    {
        papa1 = 0;
        scis1 = 0;
        rock1 = 0;
    }
}
//
#separate
void mode_set()
{
    if(input(mode_sw) == 0)
    {
        delay_ms(50);
        if(input(mode_sw) == 0)
        {
            mode = mode + 1;
            if(mode > 3) mode = 1; //1=win/computer, 2=lose/computer, 3=compe
            save_mode();
            count_disp = disp_value;
            if(mode==1) disp=16;
            else if(mode==2) disp=18;
            else if(mode==3) disp=20;
        }
        while(input(mode_sw) == 0) {}
    }
    mode_display();
}
//
#separate
void mode_display()
{
    if(mode==1) 
    {
        if(count_disp > 0) count_disp = count_disp - 1;
        delay_us(40);
        if(count_disp == 0) 
        {
            if(disp == 16)
            {
                disp = 17;
                count_disp = disp_value;
            }
            else if(disp == 17)
            {
                disp = 22;  // pres
                count_disp = disp_value;
            }
            else if(disp == 22)
            {
                disp = 23;  //ss
                count_disp = disp_value;
            }
            else if(disp == 23)
            {
                disp = 16;
                count_disp = disp_value;
            }
        }
    }
    else if(mode==2)
    {
        if(count_disp > 0) count_disp = count_disp - 1;
        delay_us(40);
        if(count_disp == 0) 
        {
            if(disp == 18)
            {
                disp = 19;
                count_disp = disp_value;
            }
            else if(disp == 19)
            {
                disp = 22;
                count_disp = disp_value;
            }
            else if(disp == 22)
            {
                disp = 23;
                count_disp = disp_value;
            }
            else if(disp == 23)
            {
                disp = 18;
                count_disp = disp_value;
            }
        }
    }
    else if(mode==3)
    {
        if(count_disp > 0) count_disp = count_disp - 1;
        delay_us(40);
        if(count_disp == 0) 
        {
            if(disp == 20)
            {
                disp = 21;
                count_disp = disp_value;
            }
            else if(disp == 21)
            {
                disp = 22;
                count_disp = disp_value;
            }
            else if(disp == 22)
            {
                disp = 23;
                count_disp = disp_value;
            }
            else if(disp == 23)
            {
                disp = 20;
                count_disp = disp_value;
            }
        }
    }
    //count_disp=100;
}
//
#separate
void mode1_action()
{
    common_action();
    mode=1;
    disp=16;
}
//
#separate
void mode2_action()
{
    common_action();
    mode=2;
    disp=18;
}
//
#separate
void mode3_action()
{
    while(keymain < 191) 
    {
        disable_interrupts(INT_TIMER1);
        set_adc_channel(1);	//must wait 65u
        delay_us(65);
        keymain = read_adc();
        enable_interrupts(INT_TIMER1);
    }
    win_count = 0;
    lose_count = 0;
    get_speed();
    //int buzzer_count=3;
    game_count=10;
    beep_time = 0;
    while(game_count > 0)
    {
        int buzzer_count=3;
        //while(buzzer_count>0)
        //{
            //
            rock1 = 0;
            scis1 = 0;
            papa1 = 0;
            rock2 = 0;
            scis2 = 0;
            papa2 = 0;
            disp=38;    // both clear
            while(((rock1 + scis1 + papa1 + rock2 + scis2 + papa2) < 2) && (buzzer_count > 0)) 
            {
                check_sw();
                if(game_speed == 0) 
                {
                    //beep30();
                    set_pwm5_duty(0x10);	// beep
                    beep_time = 12;
                    get_speed();
                    if(buzzer_count > 0) buzzer_count--;
                }
                if(beep_time == 0) set_pwm5_duty(0);	// beep off
            }
            buzzer_count=0;
            if(rock1==1)
            {
                if(rock2==1)   // rock2 vs rock
                {
                    disp=6;
                    game_count++;
                }
                else if(scis2==1)   // rock2 vs rock
                {
                    disp=0;
                    win_count++;
                }
                else if(papa2==1)   // rock2 vs rock
                {
                    disp=10;
                    lose_count++;
                }
                else 
                {
                    disp=35;
                    win_count++;    // sub lose
                }
            }
            else if(scis1==1)
            {
                if(rock2==1)   // rock2 vs rock
                {
                    disp=7;
                    lose_count++;    //
                }
                else if(scis2==1)   // rock2 vs rock
                {
                    disp=8;
                    game_count++;
                }
                else if(papa2==1)   // rock2 vs rock
                {
                    disp=1;
                    win_count++;
                }
                else 
                {
                    win_count++;
                    disp=36;
                }
            }
            else if(papa1==1)
            {
                if(rock2==1)   // rock2 vs rock
                {
                    disp=2;
                    win_count++;    //
                }
                else if(scis2==1)   // rock2 vs rock
                {
                    disp=9;
                    lose_count++;
                }
                else if(papa2==1)   // rock2 vs rock
                {
                    disp=11;
                    game_count++;
                }
                else 
                {
                    disp=37;
                    win_count++;
                }
            }
            else if((rock2 + scis2 + papa2) == 0) game_count++;
            else 
            {
                lose_count++;
                if(rock2==1) disp=3;
                else if(scis2==1) disp=4;
                else if(papa2==1) disp=5;
            }
            rock1=0;
            scis1=0;
            papa1=0;
            rock2=0;
            scis2=0;
            papa2=0;
        //}
        while((keymain < 191) || (keysub < 191)) 
        {
            disable_interrupts(INT_TIMER1);
            set_adc_channel(1);	//must wait 65u
            delay_us(65);
            keymain = read_adc();
            set_adc_channel(2);	//must wait 65u
            delay_us(65);
            keysub = read_adc();
            enable_interrupts(INT_TIMER1);
        }
        beep100();
        if(game_count > 0) game_count = game_count - 1;
    }
    rock1=0;
    scis1=0;
    papa1=0;
    result_display();
    beep1000();
    beep1000();
    delay_ms(1000);
    //
    mode=3;
    disp=20;
}
//
#separate
void common_action()
{
    while(keymain < 191) 
    {
        disable_interrupts(INT_TIMER1);
        set_adc_channel(1);	//must wait 65u
        delay_us(65);
        keymain = read_adc();
        enable_interrupts(INT_TIMER1);
    }
    win_count = 0;
    lose_count = 0;
    get_speed();
    //int buzzer_count=3;
    game_count=10;
    beep_time = 0;
    while(game_count > 0)
    {
        int buzzer_count=3;
        while(buzzer_count>0)
        {
            int rand_value=0;
            rand_value = rand();
            if(rand_value < 33) disp=3; // rock2
            else if(rand_value < 66) disp=4; // scis2
            else disp=5; // papa2
            if(pre_disp == disp) 
            {
                disp = disp + 1;
                if(disp > 5) disp = 3;
            }
            pre_disp = disp;
            //
            rock1 = 0;
            scis1 = 0;
            papa1 = 0;
            while(((rock1 + scis1 + papa1) == 0) && (buzzer_count > 0)) 
            {
                check_sw();
                if(game_speed == 0) 
                {
                    //beep30();
                    set_pwm5_duty(0x10);	// beep
                    beep_time = 12;
                    get_speed();
                    if(buzzer_count > 0) buzzer_count--;
                }
                if(beep_time == 0) set_pwm5_duty(0);	// beep off
            }
            buzzer_count=0;
            if((disp == 3) && (rock1==1))   // rock2 vs rock1
            {
                disp=6;
            }
            else if((disp == 3) && (scis1==1))  // rock2 vs scis1
            {
                disp=7;
                lose_count++;
            }
            else if((disp == 3) && (papa1==1))   // rock2 vs papa1
            {
                disp=2;
                win_count++;
            }
            else if((disp == 4) && (rock1==1))   // scis2 vs rock1
            {
                disp=0;
                win_count++;
            }
            else if((disp == 4) && (scis1==1))   // scis2 vs scis1
            {
                disp=8;
            }
            else if((disp == 4) && (papa1==1))   // scis2 vs papa1
            {
                disp=9;
                lose_count++;
            }
            else if((disp == 5) && (rock1==1))   // papa2 vs rock1
            {
                disp=10;
                lose_count++;
            }
            else if((disp == 5) && (scis1==1))   // papap2 vs scis1
            {
                disp=1;
                win_count++;
            }
            else if((disp == 5) && (papa1==1))   // papa2 vs papa1
            {
                disp=11;
            }
            rock1=0;
            scis1=0;
            papa1=0;
            
        }
        while(keymain < 191) 
        {
            disable_interrupts(INT_TIMER1);
            set_adc_channel(1);	//must wait 65u
            delay_us(65);
            keymain = read_adc();
            enable_interrupts(INT_TIMER1);
        }
        beep100();
        game_count = game_count - 1;
    }
    rock1=0;
    scis1=0;
    papa1=0;
    result_display();
    beep1000();
    beep1000();
    delay_ms(1000);
}
//
#separate
void start_display()
{
    //disp= 22;
    if(count_disp > 0) count_disp = count_disp - 1;
    if(count_disp == 0) 
    {
        if(disp == 22)
        {
            disp = 23;
            count_disp = 200;
        }
        else
        {
            disp = 22;
            count_disp = 200;
        }
    }
}
//
#separate
void result_display()
{
    if(mode==1 || mode==3)
    {
        switch(win_count)
        {
            case 0:
                disp=24;
                break;
            case 1:
                disp=25;
                break;
            case 2:
                disp=26;
                break;
            case 3:
                disp=27;
                break;
            case 4:
                disp=28;
                break;
            case 5:
                disp=29;
                break;
            case 6:
                disp=30;
                break;
            case 7:
                disp=31;
                break;
            case 8:
                disp=32;
                break;
            case 9:
                disp=33;
                break;
            case 10:
                disp=34;
                break;
            default:
                break;
        }
    }
    else if(mode==2)
    {
        switch(lose_count)
        {
            case 0:
                disp=24;
                break;
            case 1:
                disp=25;
                break;
            case 2:
                disp=26;
                break;
            case 3:
                disp=27;
                break;
            case 4:
                disp=28;
                break;
            case 5:
                disp=29;
                break;
            case 6:
                disp=30;
                break;
            case 7:
                disp=31;
                break;
            case 8:
                disp=32;
                break;
            case 9:
                disp=33;
                break;
            case 10:
                disp=34;
                break;
            default:
                break;
        }
    }
}
//
#separate
void get_speed()
{
    disable_interrupts(INT_TIMER1);
    set_adc_channel(0);	//must wait 65u
    delay_us(65);
    game_speed = read_adc();    // 0 to 255
    game_speed = (game_speed * 8) + 120;    //120 to 2160, 0.3sec to 5.4sec
    enable_interrupts(INT_TIMER1);
}
//
#separate
void save_mode() 
{
   write_eeprom(0, mode);
}   
